<ion-content>
    <ion-refresher slot="fixed" (ionRefresh)="onRefresh($event)">
        <ion-refresher-content pullingIcon="arrow-down" refreshingSpinner="circles">
        </ion-refresher-content>
    </ion-refresher>

    <ion-fab vertical="bottom" horizontal="end" slot="fixed"  style="padding-bottom: 20px;">
        <ion-fab-button [routerLink]="['/security/add-visitor-log']">
          <ion-icon name="add"></ion-icon>
        </ion-fab-button>
      </ion-fab>

    <div *ngIf="!this.cache?.isLoading">

        <ion-list *ngFor="let visitorLog of this.cache?.objects; index as i">
            <ion-card  (click)="this.cache.getObject(visitorLog.id)">
                <ion-item>
                    <ion-avatar slot="start">
                        <img [src]="visitorLog.visitor.profilePicture.content" />
                    </ion-avatar>
                    <ion-label>{{visitorLog?.visitor?.name}}</ion-label>
                    <ion-icon end *ngIf="visitorLog.unRead" name="mail-unread"></ion-icon>
                </ion-item>
                <div>
                    <ion-grid>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="person"></ion-icon>
                                {{visitorLog?.contactPerson?.name}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="home"></ion-icon>
                                {{visitorLog?.visitingTo?.name}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="time"></ion-icon>
                                {{getLocalTime(visitorLog.timeIn) | date:'medium'}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="exit"></ion-icon>
                                {{getLocalTime(visitorLog.timeOut) | date:'medium'}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <div *ngIf="visitorLog.isBookedInAdvance">
                                <ion-chip color="success">
                                    <ion-icon name="checkmark"></ion-icon>
                                    <ion-label>{{ 'Booked' | translate }}</ion-label>
                                </ion-chip>
                                <div *ngIf="visitorLog.approvalStatus === 'Pending'">
                                    <ion-chip color="primary">
                                        <ion-icon name="stopwatch"></ion-icon>
                                        <ion-label>{{ 'Pending' | translate }}</ion-label>
                                    </ion-chip>
                                    <ion-button slot="end" color="primary" (click)="approve(visitorLog)">
                                        {{ 'Approve' | translate }}</ion-button>
                                </div>
                                <div *ngIf="visitorLog.approvalStatus === 'Approved' && visitorLog.timeOut == null">
                                    <ion-chip color="success">
                                        <ion-icon name="checkmark"></ion-icon>
                                        <ion-label>{{ 'Approved' | translate }}</ion-label>
                                    </ion-chip>
                                    <ion-button slot="end" color="danger" (click)="logOut(visitorLog)">
                                        {{ 'Log Exit' | translate }}</ion-button>
                                </div>
                            </div>
                            <div *ngIf="!visitorLog.isBookedInAdvance">
                                <div *ngIf="visitorLog.approvalStatus === 'Approved' && visitorLog.timeOut == null">
                                    <ion-chip color="success">
                                        <ion-icon name="checkmark"></ion-icon>
                                        <ion-label>{{ 'Approved' | translate }}</ion-label>
                                    </ion-chip>
                                    <ion-button slot="end" color="danger" (click)="logOut(visitorLog)">
                                        {{ 'Log Exit' | translate }}</ion-button>
                                </div>
                                <div *ngIf="visitorLog.approvalStatus === 'Rejected' && visitorLog.timeOut == null">
                                    <ion-chip color="danger">
                                        <ion-icon name="close"></ion-icon>
                                        <ion-label>{{ 'Rejected' | translate }}</ion-label>
                                    </ion-chip>
                                    <ion-button slot="end" color="danger" (click)="logOut(visitorLog)">
                                        {{ 'Log Exit' | translate }}</ion-button>
                                </div>
                                <div *ngIf="visitorLog.approvalStatus === 'Hold'">
                                    <ion-chip color="warning">
                                        <ion-icon name="hand"></ion-icon>
                                        <ion-label>{{ 'Hold' | translate }}</ion-label>
                                    </ion-chip>
                                    <ion-button slot="end" color="primary" (click)="ping(visitorLog)">
                                        {{ 'Ping' | translate }}</ion-button>
                                </div>
                                <div *ngIf="visitorLog.approvalStatus === 'Pending'">
                                    <ion-chip color="primary">
                                        <ion-icon name="stopwatch"></ion-icon>
                                        <ion-label>{{ 'Pending' | translate }}</ion-label>
                                    </ion-chip>
                                    <ion-button slot="end" color="primary" (click)="ping(visitorLog)">
                                        {{ 'Ping' | translate }}</ion-button>
                                </div>
                            </div>
                        </ion-row>
                        <ion-row *ngIf="visitorLog?._cache_pending_operation == 'add'" style="color: orangered;">
                            <ion-icon name="alert"> </ion-icon>
                            {{ 'ADDED: not synced to server' | translate }}
                        </ion-row>
                        <ion-row *ngIf="visitorLog?._cache_pending_operation == 'update'" style="color: goldenrod;">
                            <ion-icon name="alert">r</ion-icon>
                            {{ 'UPDATED: not synced to server' | translate }}
                        </ion-row>
                        <ion-row *ngIf="visitorLog?._cache_pending_operation == 'delete'" style="color: red;">
                            <ion-icon name="alert">r</ion-icon>
                            {{ 'DELETED: not synced to server' | translate }}
                        </ion-row>
                    </ion-grid>
                </div>
            </ion-card>
        </ion-list>
        <ion-card *ngIf="!this.cache?.isLoading && this.cache?.objects.length==0">
            <ion-item>
                <ion-label>{{ 'No records found!!!' | translate }}</ion-label>
            </ion-item>
        </ion-card>

        <ion-infinite-scroll threshold="100px" (ionInfinite)="loadNext($event)">
            <ion-infinite-scroll-content loadingSpinner="bubbles" loadingText="Loading ...">
            </ion-infinite-scroll-content>
        </ion-infinite-scroll>
    </div>

    <ion-card *ngIf="this.cache?.isLoading && this.cache?.objects.length==0">
        <ion-card-header>
            <ion-card-title>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-card-title>
            <ion-card-subtitle>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-card-subtitle>
        </ion-card-header>

        <ion-card-content>
            <ion-item>
                <ion-label>
                    <ion-skeleton-text animated></ion-skeleton-text>
                </ion-label>
            </ion-item>
            <div>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
            </div>
        </ion-card-content>
    </ion-card>

</ion-content>